#!/usr/bin/webif-page
<?
###
 #
 # FreeWLAN Addons - http://www.freewlan.info
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
 # as published by the Free Software Foundation; either version 2
 # of the License, or (at your option) any later version.
 #
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 # GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 # MA  02110-1301, USA
 #
 # http://www.gnu.org/copyleft/gpl.html
 #
###

. /usr/lib/webif/webif.sh

validate <<EOF
string|FORM_submit|@TR<<Submit>>|max=10|$FORM_submit
EOF

save_repeater_dhcpconf() {
if [ "x$FORM_eth0_dhcp" = "x1" ];then
cat <<EOF >/etc/dnsmasq.repeater
dhcp-leasefile=/var/dhcp.leases
interface=eth0
dhcp-range=$FORM_eth0_dhcp_from,$FORM_eth0_dhcp_to,12h
dhcp-option=1,$FORM_eth0_mask
dhcp-option=3,$FORM_eth0_dhcp_gw
dhcp-option=6,$FORM_eth0_dhcp_ns
read-ethers
EOF
fi
}

if [ "$?" != "0" ]
then
	FORM_submit=""
fi

load_settings router
get_default mode mode mode

if empty "$FORM_submit"; then
	config_load fon
	get_default ipaddr lan ipaddr
	get_default netmask lan netmask
	get_default dhcp lan dhcp
	get_default lan_wan access lan_wan
	get_default hs_lan access hotspot_lan
	get_default hs_wan access hotspot_wan
	config_load router
	get_default eth0_on eth0 eth0_on
	get_default eth0_nat eth0 eth0_nat
	get_default eth0_ip eth0 eth0_ip
	get_default eth0_mask eth0 eth0_mask
	get_default eth0_dhcp_from eth0 eth0_dhcp_from
	get_default eth0_dhcp_to eth0 eth0_dhcp_to
	get_default eth0_dhcp eth0 eth0_dhcp
	get_default eth0_dhcp_gw eth0 eth0_dhcp_gw
	get_default eth0_dhcp_ns eth0 eth0_dhcp_ns
	config_load remote
	get_default ssh method ssh
	get_default rssh method rssh
	get_default webif method webif
else

validate <<EOF
ip|FORM_ipaddr|@TR<<IP Address>>|required|$FORM_ipaddr
ip|FORM_netmask|@TR<<Netmask>>|required|$FORM_netmask
bool|FORM_dhcp|@TR<<DHCP Server>>|required|$FORM_dhcp
bool|FORM_lan_wan|@TR<<Private->WAN>>|required|$FORM_lan_wan
bool|FORM_hs_lan|@TR<<Public->Private>>|required|$FORM_hs_lan
bool|FORM_hs_wan|@TR<<Public->WAN>>|required|$FORM_hs_wan
bool|FORM_ssh|@TR<<SSH access>>|required|$FORM_ssh
bool|FORM_rssh|@TR<<WAN SSH access>>|required|$FORM_rssh
bool|FORM_webif|@TR<<WAN Webinterface access>>|required|$FORM_webif
EOF

	equal "$?" 0 && {
		save_setting fon lan ipaddr "$FORM_ipaddr"
		save_setting fon lan netmask "$FORM_netmask"
		save_setting fon lan dhcp "$FORM_dhcp"
		save_setting fon access lan_wan "$FORM_lan_wan"
		save_setting fon access hotspot_lan "$FORM_hs_lan"
		save_setting fon access hotspot_wan "$FORM_hs_wan"
		save_setting remote method ssh "$FORM_ssh"
		save_setting remote method rssh "$FORM_rssh"
		save_setting remote method webif "$FORM_webif"
		save_setting router eth0 eth0_on "$FORM_eth0_on"
		save_setting router eth0 eth0_nat "$FORM_eth0_nat"
		save_setting router eth0 eth0_ip "$FORM_eth0_ip"
		save_setting router eth0 eth0_mask "$FORM_eth0_mask"
		save_setting router eth0 eth0_dhcp "$FORM_eth0_dhcp"
		save_setting router eth0 eth0_dhcp_from "$FORM_eth0_dhcp_from"
		save_setting router eth0 eth0_dhcp_to "$FORM_eth0_dhcp_to"
		save_setting router eth0 eth0_dhcp_ns "$FORM_eth0_dhcp_ns"
		save_setting router eth0 eth0_dhcp_gw "$FORM_eth0_dhcp_gw"
		commit_settings
		save_repeater_dhcpconf;
		SAVED=1
	}
fi

sel_net=1
. /usr/lib/webif/advanced.sh

header "Advanced Network Settings"

if [ "$SAVED" = "1" ]; then
	echo "<br /><br /><font color=red><b>EXECUTING CONFIGURATION</b></font>"
fi
display_form <<EOF
	infotable|Private Wireless IP Settings
	start_table|0|10|5
		add_row
			add_label_cell|@TR<<IP Address>>
			add_input_cell|ipaddr|$FORM_ipaddr|tableTextButton
		end_row
		add_row
			add_label_cell|@TR<<Netmask>>
			add_input_cell|netmask|$FORM_netmask|tableTextButton
		end_row
		add_row
			add_label_cell|@TR<<DHCP Server>>
			start_select_cell|dhcp|$FORM_dhcp|tableTextSelect
				option|0|@TR<<Disabled>>
				option|1|@TR<<Enabled>>
			end_select_cell
		end_row
		add_row
			add_button_cell|submit|@TR<<Submit>>|tableTextButton
		end_row
	end_table
EOF
cat <<EOF
<script language="Javascript1.5" type="text/javascript">
<!--
function eth0switchchange() {
	set_visible('mode_eth0', isset('eth0_on', '1'));
}
function eth0dhcpchange() {
	set_visible('eth0dhcp', isset('eth0_dhcp', '1'));
}
-->
</script>
EOF

equal "$FORM_mode" 2 && {
display_form <<EOF
	infotable|LAN Interface Settings
	infotable|LAN_If_Info#Here you can configure the behavior of the LAN interface and its IP settings.
	start_table|0|10|5
			onchange|eth0switchchange
			add_row
				add_label_cell|@TR<<WAN Interface>>
				start_select_cell|eth0_on|$FORM_eth0_on|tableTextSelect
					option|0|@TR<<Disabled>>
					option|1|@TR<<Enabled>>
					option|3|FON
				end_select_cell
			end_row
		end_table
		start_div|mode_eth0
			start_table|0|10|5
				add_row
					add_label_cell|@TR<<IP Address>>
					add_input_cell|eth0_ip|$FORM_eth0_ip|tableTextButton
				end_row
				add_row
					add_label_cell|@TR<<Netmask>>
					add_input_cell|eth0_mask|$FORM_eth0_mask|tableTextButton
				end_row
				onchange|eth0dhcpchange
				add_row	
					add_label_cell|@TR<<DHCP Server>>
					start_select_cell|eth0_dhcp|$FORM_eth0_dhcp|tableTextSelect
						option|0|@TR<<Disabled>>
						option|1|@TR<<Enabled>>
					end_select_cell
				end_row
			end_table
			start_div|eth0dhcp
			 start_table|0|10|5
				add_row
					add_label_cell|@TR<<Range from>>
					add_input_cell|eth0_dhcp_from|$FORM_eth0_dhcp_from|tableTextButton
				end_row
				add_row
					add_label_cell|@TR<<Range to>>
					add_input_cell|eth0_dhcp_to|$FORM_eth0_dhcp_to|tableTextButton
				end_row
				add_row
					add_label_cell|@TR<<Nameserver>>
					add_input_cell|eth0_dhcp_ns|$FORM_eth0_dhcp_ns|tableTextButton
				end_row
				add_row
					add_label_cell|@TR<<Gateway>>
					add_input_cell|eth0_dhcp_gw|$FORM_eth0_dhcp_gw|tableTextButton
				end_row
				end_table
			 end_div
				start_table|0|10|5
				add_row
					add_label_cell|@TR<<NAT>>
					start_select_cell|eth0_nat|$FORM_eth0_nat|tableTextSelect
							option|1|@TR<<Enabled>>
							option|0|@TR<<Disabled>>
					end_select_cell
				end_row
			 end_table
		end_div
		start_table|0|10|5
			add_row
				add_button_cell|submit|@TR<<Submit>>|tableTextButton
			end_row
		end_table
call_js|eth0switchchange
call_js|eth0dhcpchange
EOF
}

display_form <<EOF
	infotable|Firewall settings
	infotable|FirewallInfo#Here you can configure the access policies between your different networks.
	start_table|0|10|5
		add_row
			add_label_cell|@TR<<Public -> Private>>
			start_select_cell|hs_lan|$FORM_hs_lan|tableTextSelect
				option|1|@TR<<Allow>>
				option|0|@TR<<Deny>>
			end_select_cell
			add_label_cell|@TR<<SSH access>>
			start_select_cell|ssh|$FORM_ssh|tableTextSelect
				option|1|@TR<<Allow>>
				option|0|@TR<<Deny>>
			end_select_cell
		end_row
		add_row
			add_label_cell|@TR<<Public -> WAN>>
			start_select_cell|hs_wan|$FORM_hs_wan|tableTextSelect
				option|1|@TR<<Allow>>
				option|0|@TR<<Deny>>
			end_select_cell
			add_label_cell|@TR<<WAN SSH access>>
			start_select_cell|rssh|$FORM_rssh|tableTextSelect
				option|1|@TR<<Allow>>
				option|0|@TR<<Deny>>
			end_select_cell
		end_row
		add_row
			add_label_cell|@TR<<Private -> WAN>>
			start_select_cell|lan_wan|$FORM_lan_wan|tableTextSelect
				option|1|@TR<<Allow>>
				option|0|@TR<<Deny>>
			end_select_cell
			add_label_cell|@TR<<WAN Webinterface access>>
			start_select_cell|webif|$FORM_webif|tableTextSelect
				option|1|@TR<<Allow>>
				option|0|@TR<<Deny>>
			end_select_cell
		end_row
	end_table
	start_table|0|10|5
		add_row
			add_button_cell|submit|@TR<<Submit>>|tableTextButton
		end_row
	end_table
EOF

footer

if [ "$SAVED" = "1" ]; then
SAVED=0
display_form <<EOF
	autoloadpage|adv_net|15
EOF
	sleep 2
	lock -u /var/run/restart-services
	lock -u /var/run/network-connection
	if enabled $FORM_ssh
	then
		/etc/init.d/S50dropbear start
	else
		/etc/init.d/S50dropbear stop
	fi
	. /etc/firewall.user
fi;

?>