#!/usr/bin/webif-page
<?

###
 #
 # FreeWLAN Addons - http://www.freewlan.info
 #
 # This Script is based on the original La Fonera Firmware version 0.7.1r2
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
 # as published by the Free Software Foundation; either version 2
 # of the License, or (at your option) any later version.
 #
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 # GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 # MA  02110-1301, USA
 #
 # http://www.gnu.org/copyleft/gpl.html
 #
###

. /usr/lib/webif/webif.sh

validate <<EOF
	string|FORM_submit|@TR<<Submit>>|max=10|$FORM_submit
EOF

if [ "$?" != "0" ]; then
	FORM_submit=""
fi

load_settings fon
if empty "$FORM_submit"; then
	get_default mode wan mode
	get_default ip wan ipaddr
	get_default netmask wan netmask
	get_default gateway wan gateway
	get_default dns wan dns
	get_default username wan username
	get_default password wan password
	get_default pptp_server wan pptp_server
	get_default bridge wan bridge
	get_default key wan key
	get_default rssid wan rssid
	get_default dhcp wan dhcp
	get_default enc wan enc
	get_default dhcpname wan dhcpname
	FORM_hostname=`cat /etc/hostname`
	FORM_dhcpname=${FORM_dhcpname:-`cat /etc/hostname`}
else
validate <<EOF
	conn_type|FORM_mode|@TR<<Mode>>||$FORM_mode
EOF

	equal "$?" 0 && {
		case "$FORM_mode" in
			static)
				V_S="required"
			;;
			pppoe)
				V_PPP="required"
			;;
			pptp)
				V_PPP="required"
				V_PPTP="required"
			;;
			wlan)
				V_S="required"
				V_WLAN="required"
			;;
		esac

	validate <<EOF
	ip|FORM_ip|@TR<<IP Address>>|$V_S|$FORM_ip
	ip|FORM_netmask|@TR<<Netmask>>|$V_S|$FORM_netmask
	ip|FORM_gateway|@TR<<Default Gateway>>|$V_S|$FORM_gateway
	ip|FORM_pptp_server|@TR<<PPTP Server IP>>|$V_PPTP|$FORM_pptp_server
	string|FORM_username|@TR<<Username>>|$V_PPP max=32|$FORM_username
	string|FORM_password|@TR<<Password>>|$V_PPP max=32|$FORM_password
	string|FORM_key|@TR<<Encryption Key>>|$V_WLAN max=32|$FORM_key
	string|FORM_rssid|@TR<<Remote SSID>>|$V_WLAN max=32|$FORM_rssid
	string|FORM_dhcpname|@TR<<DHCP Name>>|$V_WLAN max=32|$FORM_dhcpname
	string|FORM_hostname|@TR<<Hostname>>|max=32|$FORM_hostname
EOF
	if [ -n "$FORM_dns" ]; then
	validate <<EOF
		ip|FORM_dns|@TR<<DNS Address>>|$V_S|$FORM_dns
EOF
	fi

		equal "$?" 0 && {
			save_setting fon wan mode "$FORM_mode"
			save_setting fon wan dns "$FORM_dns"
			if [ -n "$FORM_hostname" ]; then
				echo "$FORM_hostname" >/etc/hostname
				sysctl -w kernel.hostname=$FORM_hostname >/dev/null
			fi
			case "$FORM_mode" in
				static|dhcp|wlan)
					save_setting fon wan ipaddr "$FORM_ip"
				;;
				pppoe|pptp)
					save_setting fon wan username "$FORM_username"
					save_setting fon wan password "$FORM_password"
				;;
			esac
			case "$FORM_mode" in
				static|wlan)
					save_setting fon wan netmask "$FORM_netmask"
					save_setting fon wan gateway "$FORM_gateway"
				;;
				pptp)
					save_setting fon wan pptp_server "$FORM_pptp_server"
				;;
			esac
			case "$FORM_mode" in
				wlan)
					save_setting fon wan key "$FORM_key"
					save_setting fon wan rssid "$FORM_rssid"
					save_setting fon wan dhcp "$FORM_dhcp"
					save_setting fon wan enc "$FORM_enc"
					if [ -n "$FORM_dhcpname" ]; then
						save_setting fon wan dhcpname "$FORM_dhcpname"
					else
						FORM_dhcpname=${FORM_dhcpname:-`cat /etc/hostname`}
						save_setting fon wan dhcpname "$FORM_dhcpname"
					fi
					save_setting fon wan mode "wlan"
					save_setting fon wan key "$FORM_key"
					save_setting fon wan ipaddr "$FORM_ip"
					save_setting fon wan rssid "$FORM_rssid"
					save_setting fon wan dhcp "$FORM_dhcp"
					save_setting fon wan enc "$FORM_enc"
					save_setting fon wan netmask "$FORM_netmask"
					save_setting fon wan gateway "$FORM_gateway"
					save_setting fon wan dns "$FORM_dns"
					save_setting fon wan dhcpname "$FORM_dhcpname"
					if [ "$FORM_enc" == "WPA" ]; then
						echo 'ap_scan=1' > /etc/wpa_supplicant.conf
						echo 'network={' >> /etc/wpa_supplicant.conf
						echo 'ssid="'$FORM_rssid'"' >> /etc/wpa_supplicant.conf
						echo 'scan_ssid=1' >> /etc/wpa_supplicant.conf
						echo 'psk="'$FORM_key'"' >> /etc/wpa_supplicant.conf
						echo 'priority=2' >> /etc/wpa_supplicant.conf
						echo '}' >> /etc/wpa_supplicant.conf
					else
						rm -f /etc/wpa_supplicant.conf
					fi
				;;
				static|dhcp|pptp|pppoe)
					#save_setting router mode mode "1"
					save_setting fon wan mode $FORM_mode
				;;
			esac
			commit_settings
			SAVED=1
		}
	}
fi

sel_conn=1
. /usr/lib/webif/advanced.sh

header "Internet_connection#Internet Connection Settings"

cat <<EOF
<script type="text/javascript">
<!--
function modechange() {
	set_visible('static', (isset('mode', 'static') || isset('mode', 'wlan')));
	set_visible('ppp', (isset('mode', 'pppoe') || isset('mode', 'pptp')));
	set_visible('pptp', isset('mode', 'pptp'));
	set_visible('wlan', isset('mode', 'wlan'));
}
function dhcpchange() {
	if (isset('mode', 'wlan')) set_visible('static', isset('dhcp', '0'));
}
function enc_change() {
	set_visible('enc_key', !isset('enc', 'off'));
}
-->
</script>
EOF

if [ "$SAVED" = "1" ]; then
	echo "<br /><br /><font color=red><b>EXECUTING CONFIGURATION</b></font>"
	echo "<br /><br /><font color=grey><b>@TR<<autoload#The Webinterface of your Fonera will autoreload after that, please stand by>>...</b></font>"
fi

display_form <<EOF
	infotable|Connection_help#Here you can configure the way your Fonera connects to the Internet. Currently there are 5 protocols available: DHCP, static IP configuration, PPPoE, PPTP and WLAN. For most people DHCP should work; though, if it doesn't for you, check with your Internet provider (ISP) what protocol you must use or look at the installation reference manual or the troubleshooting manual from FON. If connected via WLAN, the WAN port of the Fonera may be configured in "<a href="adv_net.sh">Network Settings</a>".
	start_table|0|10|5
		add_row
			add_label_cell|@TR<<Hostname>>
			add_input_cell|hostname|$FORM_hostname|tableTextButton
		end_row
		add_row
			add_label_cell|@TR<<DNS Server>>
			add_input_cell|dns|$FORM_dns|tableTextButton
		end_row
	end_table
	start_table|0|10|5
		add_row
			onchange|modechange
			add_label_cell|@TR<<Mode>>
			start_select_cell|mode|$FORM_mode|tableTextSelect
				option|dhcp|@TR<<LAN/WAN - DHCP>>
				option|static|@TR<<LAN/WAN - Static IP>>
				option|pppoe|@TR<<LAN/WAN - PPPoE>>
				option|pptp|@TR<<LAN/WAN - PPTP>>
				option|wlan|@TR<<WLAN>>
			end_select_cell
		end_row
	end_table
	start_table|0|10|5
		add_button_cell|submit|@TR<<Submit>>
	end_table

	start_div|wlan
		infotable|Wireless Connection Settings
		start_table|0|10|5
		add_row
			add_label_cell|@TR<<Remote SSID>>
			add_input_cell|rssid|$FORM_rssid|tableTextButton
		end_row
		add_row
			onchange|enc_change
			add_label_cell|@TR<<Encryption Type>>
			start_select_cell|enc|$FORM_enc|tableTextSelect
				option|WPA|@TR<<WPA/WPA2>>
				option|WEP|@TR<<WEP>>
				option|off|@TR<<None>>
			end_select_cell
		end_row
		end_table
		start_div|enc_key
			start_table|0|10|5
			add_row
				add_label_cell|@TR<<Encryption key>>
				add_input_cell|key|$FORM_key|tableTextButton
			end_row
			end_table
		end_div
		start_table|0|10|5
		add_row
			onchange|dhcpchange
			add_label_cell|@TR<<DHCP>>
			start_select_cell|dhcp|$FORM_dhcp|tableTextSelect
				option|0|@TR<<Disabled>>
				option|1|@TR<<Enabled>>
			end_select_cell
		end_row
			add_row
			add_label_cell|@TR<<DHCP Hostname>>
			add_input_cell|dhcpname|$FORM_dhcpname|tableTextButton
		end_row
		add_button_cell|submit|@TR<<Submit>>
		end_table
	end_div

	start_div|static
		infotable|Static IP settings and Wireless IP Settings
		start_table|0|10|5
			add_row
				add_label_cell|@TR<<IP Address>>
				add_input_cell|ip|$FORM_ip|tableTextButton
			end_row
			add_row
				add_label_cell|@TR<<Network Mask>>
				add_input_cell|netmask|$FORM_netmask|tableTextButton
			end_row
			add_row
				add_label_cell|@TR<<Gateway>>
				add_input_cell|gateway|$FORM_gateway|tableTextButton
			end_row
			add_button_cell|submit|@TR<<Submit>>
		end_table
	end_div

	start_div|ppp
		infotable|PPPoE and PPTP settings
		start_table|0|10|5
			add_row
				add_label_cell|@TR<<Username>>
				add_input_cell|username|$FORM_username|tableTextButton
			end_row
			add_row
				add_label_cell|@TR<<Password>>
				add_input_cell|password|$FORM_password|tableTextButton
			end_row
			add_button_cell|submit|@TR<<Submit>>
		end_table
	end_div

	start_div|pptp
		infotable|PPTP Settings
		start_table|0|10|5
			add_row
				add_label_cell|@TR<<PPTP Server IP>>
				add_input_cell|pptp_server|$FORM_pptp_server|tableTextButton
			end_row
			add_button_cell|submit|@TR<<Submit>>
		end_table
	end_div
	
	call_js|modechange
	call_js|enc_change
	call_js|dhcpchange
	help|connection
EOF

if [ "$SAVED" = "1" ]; then
	footer
	SAVED="0"
display_form <<EOF
		autoloadpage|connection|15
EOF
	sleep 2
	lock -u /var/run/restart-services
else
	footer
fi;

?>