#!/usr/bin/webif-page
<?

###
 #
 # FreeWLAN Addons - http://www.freewlan.info
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
 # as published by the Free Software Foundation; either version 2
 # of the License, or (at your option) any later version.
 #
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 # GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 # MA  02110-1301, USA
 #
 # http://www.gnu.org/copyleft/gpl.html
 #
###

. /usr/lib/webif/webif.sh

validate <<EOF
string|FORM_submit|@TR<<Submit>>|max=10|$FORM_submit
EOF

sel_dyndns=1
. /usr/lib/webif/advanced.sh

config_load dyndns
if empty "$FORM_submit"; then
	get_default dyn_enable dyndns enable
	get_default user dyndns user
	get_default pass dyndns pass
	get_default url dyndns url
else
	enabled $FORM_dyn_enable &&\
	validate <<EOF
bool|FORM_dyn_enable|@TR<<DynDNS>>|required|$FORM_dyn_enable
string|FORM_user|@TR<<Username>>|required|$FORM_user
string|FORM_pass|@TR<<Password>>|required|$FORM_pass
dyndns|FORM_url|@TR<<URL>>|required|$FORM_url
EOF
	equal "$?" 0 && {
		save_setting dyndns dyndns enable "$FORM_dyn_enable"
		save_setting dyndns dyndns user "$FORM_user"
		save_setting dyndns dyndns pass "$FORM_pass"
		save_setting dyndns dyndns url "$FORM_url"
		commit_settings
		rm -f /etc/config/ip.cache
		rm -f /tmp/dyndns.lock
		/bin/dyndns
		SAVED=1
	}
	enabled $FORM_enable || {
	        save_setting dyndns dyndns enable "$FORM_dyn_enable"
	        commit_settings
	        SAVED=1
	}
fi

header "DynDNS"

cat <<EOF
<script language="Javascript1.5" type="text/javascript">
<!--
function modechange() {
   set_visible('mode_DynDNS', isset('dyn_enable', '1'));
}
-->
</script>
EOF

display_form <<EOF
	infotable|Advanced_dyndns#Here you can configure DynDNS updates.
	start_table|0|10|5
		onchange|modechange
		add_row
			add_label_cell|@TR<<DynDNS>>:
			start_select_cell|dyn_enable|$FORM_dyn_enable|tableTextSelect
				option|0|@TR<<Disabled>>
				option|1|@TR<<Enabled>>
			end_select_cell
		end_row
	end_table
	start_div|mode_DynDNS
		start_table|0|10|5
			add_row
				add_label_cell|@TR<<Username>>:
				add_input_cell|user|$FORM_user|tableTextButton
			end_row
			add_row
				add_label_cell|@TR<<Password>>:
				add_pass_cell|pass|tableTextButton|$FORM_pass
			end_row
			add_row
				add_label_cell|@TR<<URL>>:
				add_input_cell|url|$FORM_url|tableTextButton
			end_rowend_div
		end_table
	end_div	
	start_table|0|10|5
		add_row
			add_button_cell|submit|@TR<<Submit>>|tableTextButton
		end_row
	end_table
	help|dyndns
call_js|modechange
EOF

if [ -f /tmp/dyndns.lock ]
then
	display_form <<EOF
	start_table|0|10|5
		add_row
			add_label_cell|@TR<<dyndns_error#There is an error in your DynDNS settings. Updates have been disabled.>>
		end_row
	end_table		
EOF
fi

footer ?>